struct vect
	{
	float x, y;
	};

class Object
	{
	protected:
		//int fdelay;
		//static list <Object *> objs;
		int id;
		Uint8 animNum, frame, fspeed, layer, fdelay;		// Zmienne animacyjne
		Anim *anim;
		float x, y;										// Zmienne ruchowe
		Sprite *sprite;									// Grafiki

		vect grav;
		vect res;
		vect vectors;									// Do czego to bylo...	// Predkosc ruchu x/y?
		vect maxVectors;
	public:


		Object(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, bool spriteIgnore=0);	// Konstruktor
		Object();
//		virtual void update();
		virtual void move();
		virtual void print();
		virtual void animFinished();

		virtual bool getCol(Object &obj1, Object &obj2);

		/*void setAnim(Uint8 sAnim);
		void setFrame(Uint8 sFrame);
		void setFspeed(Uint8 sFspeed);
		void setLayer(Uint8 sLayer);
		void setFdelay(Uint8 sDelay);
		void setPos(float sx, float sy);
		void setSprite(Sprite *sSprite);
		void setGrav(vect sGrav);
		void setRes(vect sRes);
		void setVectors(vect sVectors);
		void setMaxVectors(vect sMaxVectors);

		Uint8 getAnimNum();
		Anim* getAnim();
		int getAnimCount();
		Uint8 getFrame();
		Uint8 getFspeed();
		Uint8 getLayer();
		Uint8 getFdelay();
		void getPos(float &sx, float &sy);
		float getX();
		float getY();
		Sprite* getSprite();
		vect getGrav();
		vect getRes();
		vect getVectors();
		vect getMaxVectors();*/

		inline void setAnim(Uint8 sAnim)
			{
			if(!sprite)
				return;
			if(sAnim>=sprite->getAnimCount())
				sAnim%=sprite->getAnimCount();
			animNum=sAnim;
			anim=sprite->getAnim(sAnim);
			}

		inline void setFrame(Uint8 sFrame)		{frame=sFrame;}
		inline void setFspeed(Uint8 sFspeed)	{fspeed=sFspeed;}
		inline void setLayer(Uint8 sLayer)		{layer=sLayer;}
		inline void setFdelay(Uint8 sDelay)		{fdelay=sDelay;}
		inline void setPos(float sx, float sy)	{x=sx;y=sy;}
		inline void setSprite(Sprite *sSprite)	{sprite=sSprite;}
		inline void setGrav(vect sGrav)			{grav=sGrav;}
		inline void setRes(vect sRes)			{res=sRes;}
		inline void setVectors(vect sVectors)	{vectors=sVectors;}
		inline void setMaxVectors(vect sMaxVectors)	{maxVectors=sMaxVectors;}
		inline Uint8 getAnimNum()				{return animNum;}
		inline Anim* getAnim()					{return anim;}
		inline int getAnimCount()				{return sprite->getAnimCount();}
		inline Uint8 getFrame()					{return frame;}
		inline Uint8 getFspeed()				{return fspeed;}
		inline Uint8 getLayer()					{return layer;}
		inline Uint8 getFdelay()				{return fdelay;}
		inline void getPos(float &sx, float &sy){sx=x;sy=y;}
		inline float getX()						{return x;}
		inline float getY()						{return y;}
		inline Sprite* getSprite()				{return sprite;}
		inline vect getGrav()					{return grav;}
		inline vect getRes()					{return res;}
		inline vect getVectors()				{return vectors;}
		inline vect getMaxVectors()				{return maxVectors;}
	};

