#include "main.h"

Weapon::~Weapon()
	{
	//updateRect(floor(x)-anim->spotx, floor(y)-anim->spoty, anim->w, anim->h);
	//if(anim)
	//	updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
	}

void Explosion::move()
	{
	//printf("%d %d %d %d\n", (int)floor(x)-anim->spotx, (int)floor(y)-anim->spoty, anim->w, anim->h);
	updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
	//updateRect((int)x-64, (int)y-64, 128, 128);
	if(time--<=0)
		{
		done=1;
		return;
		}
	print();
	if(power<0)
		return;
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		if((*it)->getHp()<=0)
			continue;
		int odl=sqrt(pow((*it)->getX()-x, 2)+pow((*it)->getY()-y, 2));
		if(odl<64)
			(*it)->setHp((*it)->getHp()-power);
		//if((*it)->getHp()<=0)
		//	gkills++;
		}
	}

void Bomb::move()
	{
	updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
	if(time--<=0)
		{
		done=1;
		return;
		}
	if(time==96)
		setAnim(min(getAnimCount()-1, 1));
	else if(time<60 && time%5==0)
		{
		int w=screen->w/10;
		int h=screen->h/10;
		for(int i=0; i<5; i++)
			{
			weps.push_back(new Explosion(0, x-rand()%(w*2)+w, y-rand()%(h*2)+h, gfx["wybuch01.bmp"], grav, res, 15));
			weps.back()->setAnim(rand()%gfx["wybuch01.bmp"]->getAnimCount());
			}
		}
	if(time>30)
		print();
	}

void Flame::move()
	{
	if(time--<=0)
		{
		done=1;
		return;
		}
	int w=screen->w/10;
	for(int i=0; i<10; i++)
		{
		particles.push_back(Particle(gfx["particle.bmp"], x+rand()%(w*2)-w, y, grav, res, 90,  screen->h/90+rand()%20/10.0+0.5, 200));
		particles.back().setAnim(rand()%particles.back().getAnimCount()/2*2);
		}
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		if((*it)->getHp()<=0)
			continue;
		if((*it)->getX()>x-w && (*it)->getX()<x+w)
			(*it)->setHp((*it)->getHp()-2);
		//if((*it)->getHp()<=0)
		//	gkills++;
		}
	}

void Airstrike::move()
	{
	if(time<10)
		time++;
	else if(count<6)
		{
		weps.push_back(new Airstrike(0, tgx-32, tgy, sprite, grav, res, count+1));
		count=10;
		}
	if(y<tgy)
		{
		updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
		vectors.y+=grav.y;
		y+=vectors.y;
		updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
		print();
		}
	else
		done=1;
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		if((*it)->getHp()<=0)
			continue;
		if(Object::getCol(*(*it), *this))
			{
			(*it)->setHp(0);
			//gkills++;
			done=1;
			}
		}
	if(done)
		{
		weps.push_back(new Explosion(0, x, y, gfx["wybuch01.bmp"], grav, res, 25));
		weps.back()->setAnim(rand()%gfx["wybuch01.bmp"]->getAnimCount());
		for(int i=0; i<10; i++)
			{
			particles.push_back(Particle(gfx["particle.bmp"], x, y, grav, res, rand()%360,  rand()%20/10.0+0.5, 50));
			particles.back().setAnim(rand()%particles.back().getAnimCount()/2*2);
			}
		}
	}

void Armageddon::move()
	{
	if(y<tgy)
		{
		updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
		vectors.y+=grav.y;
		y+=vectors.y;
		x-=vectors.y;
		print();
		}
	else if(time<30)
		{
		time++;
		if(time%10==0)
			{
			weps.push_back(new Explosion(0, x-rand()%48+24, y-rand()%48+24, gfx["wybuch01.bmp"], grav, res, 25*(time<10)));
			weps.back()->setAnim(rand()%gfx["wybuch01.bmp"]->getAnimCount());
			}
		}
	else
		done=1;
	updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		if((*it)->getHp()<=0)
			continue;
		if(Object::getCol(*(*it), *this))
			{
			(*it)->setHp(0);
			weps.push_back(new Explosion(0, x-rand()%48+24, y-rand()%48+24, gfx["wybuch01.bmp"], grav, res, 40));
			weps.back()->setAnim(rand()%gfx["wybuch01.bmp"]->getAnimCount());
			//gkills++;
			done=1;
			}
		}
	if(time<5 && !done)
		time++;
	else if(count<75)
		{
		weps.push_back(new Armageddon(0, rand()%(screen->w-64)+32, rand()%(screen->h-64)+32, sprite, grav, res, count+1));
		count=100;
		}
	}

void Concrete::move()
	{
	if(y<screen->h+anim->h)
		{
		updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
		vectors.y+=grav.y;
		y+=vectors.y;
//		if(vectors.y>0)
//			time++;
//		if(time>screen->h/10)
//			{
//			time=0;
//			vectors.y=-2;
//			}
		for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
			{
			if((*it)->getHp()<=0)
				continue;
			if(Object::getCol(*(*it), *this))
				{
				//time=0;
				if(vectors.y>=2)
					{
					vectors.y=-2;
					PlaySound("boing.wav");
					}
				(*it)->setHp(0);
				//gkills++;
				for(int i=0; i<10; i++)
					{
					particles.push_back(Particle(gfx["particle.bmp"], (*it)->getX(), (*it)->getY(), grav, res, rand()%360,  rand()%20/10.0+0.5, 50));
					particles.back().setAnim(rand()%particles.back().getAnimCount()/2*2);
					}
				}
			}
		updateRect((int)x-anim->spotx, (int)y-anim->spoty, anim->w, anim->h);
		print();
		}
	else
		done=1;
	}

void Muchozol::move()
	{
	time++;
	if(time%35==0)
		{
		weps.push_back(new Explosion(0, x-rand()%128+64, y-rand()%128+64, gfx["muchozol.bmp"], grav, res, 0));
		weps.back()->setAnim(rand()%gfx["muchozol.bmp"]->getAnimCount());
		if(count<3 && rand()%10==0)
			weps.push_back(new Muchozol(0, weps.back()->getX(), weps.back()->getY(), NULL, grav, res, 20*count+rand()%5, count+1));
		}
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		if((*it)->getHp()<=0)
			continue;
		int ax=(*it)->getX()-x;
		int ay=(*it)->getY()-y;
		if(sqrt(ax*ax+ay*ay)<96)
			{
			(*it)->setHp(0);
			//gkills++;
			}
		}
	if(time>10*1000/FPSDELAY)
		done=1;
	}
