/** \file main.cpp
*   \author crm
*   \date kiedys tam
*   \brief Bzzzz
*
*   Muchozol, czesc 4
*/
#include "main.h"

// Zmienne sdl'owe
SDL_Surface *screen;
SDL_Event event;
//SDL_Rect kwadrat;
//SDL_AudioSpec fmt;

// Stale
// Obraz
#ifndef DEBUG
const int SCREENWIDTH=0, SCREENHEIGHT=0;
const int SDLFLAG=SDL_SWSURFACE|SDL_FULLSCREEN;
#else
const int SCREENWIDTH=640, SCREENHEIGHT=480;
const int SDLFLAG=SDL_SWSURFACE;
#endif
// FPS
const int FPSDELAY=1000/60;			// 1000ms podzielone przez docelowy fps
// Wyniki
const char SCOREADDRSCRIPT[]="http://cremmy.cba.pl/muchozol4.php";
const char SCOREADDR[]="http://cremmy.cba.pl/muchozol4.wtf";

// Zmienne globalne
int frameTime=0;
bool update=0;
bool run=1, fullscreen=0;
Uint8 *key=SDL_GetKeyState(NULL);
SDL_Surface *icon=NULL;

// Zmienne do gry
SDL_Surface *background;			// Tlo
map <string, Sprite *> gfx;			// Grafiki
SDL_Rect bgsrc, bgdst;				// Recty do wyswietlania tla. Nie ma sensu ciagle tworzyc nowych
//vector <SDL_Rect> rects;			// Kwadraciki~
//list <SDL_Rect> rects;
//const int MAXUPDATES=1000;		// Max ilosc update kwadratow
int maxUpdates=1000;
int updates=0;				// do skasowania	// A jednak nie d;
SDL_Rect *rects=NULL;//[MAXUPDATES];
list <Particle> particles;			// Partikle ftw
list <WeaponDrop> drop;				// Amunicja? W MOIM Muchozolu!?
list <Mucha *> muchy;				// Zgodnie z nazwa, muchy
list <Weapon *> weps;				// Lista aktualnie dzialajacych broni

int mx, my;							// Wspolrzedne myszy
int mmx, mmy;						// Wspolrzedne menu
int playerHp=6;						// Zycia gracza
int anim=0;							// Animacja kursora
int gkills, gtime;					// Do wynikow
const int WEAPONCOUNT=WLAST;
const int WEAPONMENUSIZE=40;	//WEAPONCOUNT*8
unsigned int weapons[WEAPONCOUNT];	// Tablica z amunicja do broni
int currWeapon=-1;					// Aktualnie wybrana bron. Jesli <0 -> zadna
int wepClick=-1;					// int sprawdzajacy, czy kliknieto jakas bron
bool wepSel=0;						// Jesli 1 -> flip + zmiana na 0
int wepDelay=0;						// Czas do poczekania miedzy atakami
int mainWepDelay=0;					// Czas do poczekania miedzy kolejnymi atakami uzywajac glownej broni
int mode=MENU;
int menClick=-1;					// int sprawdzajacy, czy kliknieto jakas opcje z menu

CURL *curlHandle;					// Uchwyt curla
char *curlData;

SDL_AudioSpec fmt;					// Dzwiek, SDL_Audio
extern void mixaudio(void *unused, Uint8 *stream, int len);

SDL_Rect *rect(SDL_Rect *rect, Sint16 x, Sint16 y, Uint16 w, Uint16 h)
	{
	rect->x=x; rect->y=y;
	rect->w=w; rect->h=h;
	return rect;
	}

void updateRect(int x, int y, int w, int h)
	{
	updates++;
	if(update)
		return;
	if(updates<maxUpdates)
		{
		if(x+w>screen->w)
			w-=x+w-screen->w;
		if(x<0)
			{
			w+=x;
			x=0;
			}
		if(y+h>screen->h)
			h-=y+h-screen->h;
		if(y<0)
			{
			h+=y;
			y=0;
			}
		if(w<=0 || h<=0)
			{
			updates--;
			return;
			}
		//rects.push_back(SDL_Rect());	// Zalozmy, ze zadziala za kazdym razem... "Co, jaki segfault!?"
		rect(&rects[updates-1], x, y, w, h);
		}
	else
		update=1;
	}

void putPix(SDL_Surface *surf, int x, int y, Uint32 color)
	{
	if(x<0 || x>=surf->w || y<0 || y>=surf->h)
		return;
	Uint32 *pix=(Uint32 *)surf->pixels;
	/*if(fullscreen)
		pix[y*640+x]=color;
	else*/
		pix[y*surf->w+x]=color;
	}

SDL_Surface *DumpScreen(/*SDL_Surface *srf=NULL*/)			// Pamietaj o zwolnieniu przesylanego surface
	{
	SDL_Surface *srf;
#ifdef WINDOWS
	int screenW=GetSystemMetrics(SM_CXSCREEN);
	int screenH=GetSystemMetrics(SM_CYSCREEN);
	if(!screenW || !screenH)
		return NULL;

	HDC hDesktop=GetDC(NULL);
	if(!hDesktop)
		return NULL;
	HDC hCompatible=CreateCompatibleDC(hDesktop);
	if(!hCompatible)
		return NULL;
	HBITMAP hbScreen=CreateCompatibleBitmap(hDesktop, screenW, screenH);
	if(!hbScreen)
		return NULL;
	if(!SelectObject(hCompatible, hbScreen) )
		return NULL;
	if(!BitBlt(hCompatible, 0, 0, screenW, screenH, hDesktop, 0, 0, SRCCOPY|CAPTUREBLT) )
		return NULL;
	char *pxArray;
	try
		{
		pxArray=new char[screenW*screenH*4];
		}
	catch(bad_alloc &)
		{
		return NULL;
		}

	if(!GetBitmapBits(hbScreen, screenW*screenH*4, pxArray) )
		return NULL;

	/*if(srf)
		{
		printf("INFO: DumpScreen: Zwalnianie\n");
		SDL_FreeSurface(srf);
		}*/
	srf=SDL_CreateRGBSurface(SDL_SWSURFACE, screenW, screenH, 32, 0xff0000, 0xff00, 0xff, 0x00000000);
	if(!srf)
		return NULL;

	memcpy(srf->pixels, pxArray, srf->w*srf->h*4);

	ReleaseDC(NULL, hDesktop);
	DeleteDC(hCompatible);
	DeleteObject(hbScreen);
	delete [] pxArray;
/*#else
	srf=SDL_CreateRGBSurface(SDL_SWSURFACE, screen->w, screen->h, 32, 0xff0000, 0xff00, 0xff, 0x00000000);
	if(!srf)								// ^ 0         ^ 0, albo zamienic kolejnosc dla luniksa albo wymyslic cos lepszego
		return NULL;
	memset(srf->pixels, 0, screen->w*screen->h);*/
#else
	srf=SDL_CreateRGBSurface(SDL_SWSURFACE, 32, 32, 32, 0xff0000, 0xff00, 0xff, 0x00000000);
	if(!srf)
		return NULL;
#endif
	//printf("OK  : DumpScreen: Obraz przechwycony\n");
	return srf;
	}

bool createWindow(int ADDFLAG=0)
	{
	static bool init=0;
	if(init==0)
		{
		init=1;
		if(SDL_Init(SDL_INIT_VIDEO)<0)
			{
			printf("FAIL: init: Nie udalo sie zainicjowac sdl'a\n");
			return 0;
			}
		SDL_WM_SetCaption("Muchozol 2", NULL);		// na wszelki wypadek
		if(SDL_OpenAudio(&fmt, NULL)<0)
			{
			printf("FAIL: init: Nie udalo sie zainicjowac dzwieku\n");
			return 0;
			}
		SDL_PauseAudio(0);
		//return 1;
		}
	else
		{
		SDL_FreeSurface(screen);
		SDL_Quit();
		SDL_Delay(50);
		SDL_Init(SDL_INIT_VIDEO);
		SDL_OpenAudio(&fmt, NULL);
		SDL_PauseAudio(0);
		}
	if(background)
		SDL_FreeSurface(background);
	if(!(background=DumpScreen()))
		return 0;
	if(!(screen=SDL_SetVideoMode(SCREENWIDTH, SCREENHEIGHT, 32, ADDFLAG)))
		{
		printf("FAIL: init: Nie udalo sie ustawic trybu video\n");
		return 0;
		}
	printf("OK  : init: Okno zrobione (%dx%dpx)\n", screen->w, screen->h);
	bgsrc.x=0; bgsrc.y=0; bgsrc.w=screen->w; bgsrc.h=screen->h;
	bgdst.x=0; bgdst.y=0;
	SDL_WM_SetCaption("Muchozol 2", NULL);
		{
		if(icon)
			SDL_FreeSurface(icon);
		Resfile res;
		char *resIcon=res.load("data/gfx.crs", "ikona.bmp");
		icon=SDL_LoadBMP_RW(SDL_RWFromMem(resIcon, res.getLastSize()), 1);
		SDL_SetColorKey(icon, SDL_SRCCOLORKEY, SDL_MapRGB(screen->format, 255, 0, 255));
		SDL_WM_SetIcon(icon, NULL);
		delete[] resIcon;
		}
	SDL_ShowCursor(SDL_DISABLE);
#ifdef WINDOWS
	SDL_BlitSurface(background, &bgsrc, screen, &bgdst);
#else
	SDL_FillRect(screen, &bgdst, SDL_MapRGB(screen->format, 0, 0, 0));
#endif
	//rects.clear();
	//muchy.clear();
	update=1;
	return 1;
	}

int benchmark()
	{
	if(!screen)
		{
		printf("FAIL: benchmark: NULL screen\n");
		return 0;
		}
	int updTime=SDL_GetTicks();
	int maxUpdates=0;
	while((int)SDL_GetTicks()-updTime<FPSDELAY)
		{
		maxUpdates++;
		int x=rand()%screen->w/32*32;
		int y=rand()%screen->h/32*32;
		SDL_UpdateRect(screen, x, y, 16*(rand()%3+1), 16*(rand()%3+1));
		}
	//printf("INFO: benchmark: MaxUpdates: %d\n", maxUpdates);
	return maxUpdates;
	}

void getMaxUpdates()
	{
	ifstream rmaxupd("upds", ios::binary);
	if(rmaxupd.is_open())
		{
		rmaxupd.read(reinterpret_cast<char *>(&maxUpdates), sizeof(int));
		if(maxUpdates>0 && !rmaxupd.eof())
			{
			rmaxupd.close();
			return;
			}
		rmaxupd.close();
		}
	SDL_Flip(screen);
	maxUpdates=0;
	for(int i=0; i<20; i++)
		maxUpdates+=benchmark();
	maxUpdates/=20;
	ofstream wmaxupd("upds", ios::binary);
	if(!wmaxupd.is_open())
		{
		printf("FAIL: getMaxUpdates: Nie udalo sie otworzyc pliku do zapisu\n");
		return;
		}
	wmaxupd.write(reinterpret_cast<char *>(&maxUpdates), sizeof(int));
	wmaxupd.close();
	}

void restart()
	{
	mode=MENU;
	playerHp=6;
	gkills=0;
	gtime=0;
	for(int i=0; i<WEAPONCOUNT; i++)
		weapons[i]=0;
	currWeapon=-1;
	wepClick=-1;
	wepSel=0;
	mainWepDelay=-1;
	wepDelay=-1;
	menClick=-1;
	SDL_WarpMouse(screen->w/2, screen->h/2);
	SDL_GetMouseState(&mx, &my);
	particles.clear();
	muchy.clear();
	weps.clear();
	drop.clear();
	}

size_t curlWrite(void *buffer, size_t size, size_t nmemb, void *userp)
	{
	/*char tmp[32];
	sprintf(tmp, "%d-%d.txt", (int)time(NULL), SDL_GetTicks());
	ofstream dl(tmp);
	dl.write(reinterpret_cast<char *>(buffer), size*nmemb);
	dl.open("dl.txt");*/
	ofstream dl("dl.txt");
	if(!dl.is_open())
		return 0;
	dl.write(reinterpret_cast<char *>(buffer), size*nmemb);
	return size*nmemb;
	}

const char* md5(const char *data, int length)
	{
	md5_state_s state;
	md5_byte_t digest[16];
	char *hex_output;
	try
		{
		hex_output=new char[16*2+1];
		}
	catch(bad_alloc &)
		{
		return NULL;
		}

	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)data, length);
	md5_finish(&state, digest);
	for(int di=0; di<16; ++di)
	    sprintf(hex_output + di * 2, "%02x", digest[di]);
	hex_output[32]='\0';
	return hex_output;
	}

int main(/*int argc, char *argv[]*/)
	{
	#ifndef DEBUG
	freopen("log.txt", "w", stdout);
	#endif
	printf("\nINFO: Start\nINFO: Build: %s %s\n", __DATE__, __TIME__);
	srand(time(0));
	setbuf(stdout, NULL);
	fmt.freq = 22050;
	fmt.format = AUDIO_S16;
	fmt.channels = 2;
	fmt.samples = 1024;
	fmt.callback = mixaudio;
	fmt.userdata = NULL;
	if(!createWindow(SDLFLAG))
		return 100;
	// Wczytywanie grafik
	//printf("Wczytywanie grafik\n");
	Sprite::load("data/gfx.crs", gfx);		// D:/Programy/CodeBlocks/crm/Muchozol 2/bin/Release/
	//printf("Grafiki wczytane\n");
	Sprite *kursor=gfx["kursor.bmp"];		// Dwa najczesciej uzywane, warto 'przewskaznikowac'
	Sprite *mucha=gfx["mucha01.bmp"];//gfx["blah.bmp"];		// jw.
	//Sprite *particle=gfx["particle.bmp"];	// jw, z tym, ze teraz juz trzy.
	Sprite *gfxWeaponsMenu[WEAPONCOUNT];		// WBOMB=0, WFLAME, WAIRSTRIKE, WCONCRETE, WARMAGEDDON, WNUKE	// Stare nazwy o;
	gfxWeaponsMenu[WBOMB]=gfx["wep_bomb.bmp"];
	gfxWeaponsMenu[WFLAME]=gfx["wep_flame.bmp"];
	gfxWeaponsMenu[WAIRSTRIKE]=gfx["wep_airstrike.bmp"];
	gfxWeaponsMenu[WCONCRETE]=gfx["wep_concrete.bmp"];
	gfxWeaponsMenu[WARMAGEDDON]=gfx["wep_armageddon.bmp"];
	gfxWeaponsMenu[WMUCHOZOL]=gfx["wep_muchozol.bmp"];
	Text score(0, 0, 0, gfx["font_00.bmp"], "", WEAPONMENUSIZE*2+16);				// Stary tekst: bijcie masterczulki!
	Text hiscores(0, (screen->w-512)/2, screen->h/3, gfx["font_00a.bmp"], "", 512-64);	// screen->w/2		// Stary tekst: Niestety, z powodu lenistwa programisty, wyniki sa w stanie wskazujacym niedopracowanie. Pozostaje tylko miec nadzieje, ze wkrotce zostana one pozbawione tej, jakze niepotrzebnej, cechy i bedzie mozna na calym swiecie chwalic sie swoimi osiagnieciami w walce z muchami.
	Hiscore wyniki;			// Wyniki
	//char *wynikiStr=NULL;	//
	//Hiscore wynikiT;		// Po czasie
	char nick[32]="";										// Do wysylania wynikow
	char *nickChr=nick;										// Aktualnie wpisywany znak
	char lastKey=0;
	int sendState=0;										// 0 -> wpisywanie nicku, 1 -> wysylanie, 2 -> odbieranie
	curlHandle=curl_easy_init();
	//printf("MD5: %s\n", md5("lulz", 4));
	if(curlHandle==NULL)
		return 200;
	//bool once=0;											// Bool ktory moze sie przydac, przynajmniej do wysylania wynikow (ustawianie tekstow itp)
	for(int i=0; i<WEAPONCOUNT; i++)
		weapons[i]=0;
	//int *maxupdates=const_cast<int *>(&MAXUPDATES);		// Nadpisanie stalej? TIS KENT BI!	// Zgadzam sie
	//*maxupdates=2000;
	vect grav; grav.x=0; grav.y=0.04;						// Grawitacja (particle)
	vect res; res.x=0.01; res.y=0.01;						// Opor (jw)
	vect antiGrav; antiGrav.x=-grav.x; antiGrav.y=-grav.y;	// Antygrawitacja (jw?)
	SDL_WarpMouse(screen->w/2, screen->h/2);
	SDL_GetMouseState(&mx, &my);
	const int PLAYERHPANIM=kursor->getAnimCount();			// Stala z iloscia grafik kursora
	if(!kursor || !mucha)
		{
		printf("FAIL: Nie udalo sie wczytac grafik kursora/muchy\n");
		return 101;
		}
	for(int i=0; i<WEAPONCOUNT; i++)
		{
		if(gfxWeaponsMenu[i]==NULL)
			{
			printf("FAIL: Nie udalo sie wczytac grafiki broni %d\n", i);
			return 101;
			}
		}
	getMaxUpdates();
	printf("INFO: MaxUpdates: %d\n", maxUpdates);
	try
		{
		rects=new SDL_Rect[maxUpdates];
		}
	catch(bad_alloc &)
		{
		printf("FAIL: Nie udalo sie zajac miejsca na kwadraciki\n");
		return 102;
		}
	#ifndef DEBUG
	int czas=time(NULL);
	#endif
	//
	printf("INFO: Wystartowano w %dms\n", SDL_GetTicks());
	printf("--------------------------------------------------------------------------------\n");
	while(run)
		{
		frameTime=SDL_GetTicks();
		if(SDL_PollEvent(&event))		// SDL_Event event;
			{
			switch(event.type)
				{
				case SDL_VIDEORESIZE:
					//
				break;

				case SDL_QUIT:
					run=0;
				break;

				case SDL_VIDEOEXPOSE:
					update=1;
				break;
				}
			}
		if(key[SDLK_LALT] && key[SDLK_F4])
			run=0;
		if(key[SDLK_F2])
			{
			if(!createWindow(SDLFLAG))
				return 100;
			restart();
			}
		if(mode!=GAME && key[SDLK_ESCAPE])
			{
			mode=MENU;
			update=1;
			}
		/***** Dzialanie *****/
		#ifdef WINDOWS
			SDL_BlitSurface(background, NULL, screen, NULL);
		#else
			//#warning 'Lunix' is deprecated.
			SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
		#endif
		/***** Wyswietlanie gracza *****/
		int lmx=mx, lmy=my;
		updateRect(mx, my, 12, 24);
		SDL_GetMouseState(&mx, &my);
		//kursor->print(PLAYERHPANIM-PLAYERHPANIM*playerHp/100, 0, mx, my);			// Na twardo wpisana ilosc animacji zyc	// juz nie d;
		if(lmx!=mx || lmy!=my)
			{
			updateRect(mx, my, 12, 24);
			particles.push_back(Particle(kursor, lmx, lmy, grav, res, atan2(lmy-my, mx-lmx)*(180/3.14), sqrt(pow(lmx-mx, 2)+pow(lmy-my, 2))/5, 20));
			particles.back().setAnim(anim);
			}
		/***** Tryb gry *****/
		switch(mode)
			{
			case MENU:
				if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
					{
					if(mx>screen->w/2-80 && mx<screen->w/2-48 &&
						my>screen->h/2-96 && my<screen->h/2)
						//mode=GAME;
						menClick=0;
					else if(mx>screen->w/2-16 && mx<screen->w/2+16 &&
							my>screen->h/2-96 && my<screen->h/2)
						//mode=SCORE;
						menClick=1;
					else if(mx>screen->w/2+48 && mx<screen->w/2+80 &&
							my>screen->h/2-96 && my<screen->h/2)
						//run=0;
						menClick=2;
					else
						menClick=-1;
					}
				else if(menClick==0)
					{
					restart();
					update=1;
					mode=GAME;
					}
				else if(menClick==1)
					{
					sendState=0;		// informacja o koniecznosci pobrania wynikow
					menClick=-1;		// <- tymczasowe...?
					update=1;
					//mode=SENDSCORE;
					mode=SCORE;
					}
				else if(menClick==2)
					run=0;
				if(mode==MENU)
					{
					gfx["menu_start.bmp"]->print(0, menClick==0, screen->w/2-64, screen->h/2);
					gfx["menu_wyniki.bmp"]->print(0, menClick==1, screen->w/2, screen->h/2);
					gfx["menu_koniec.bmp"]->print(0, menClick==2, screen->w/2+64, screen->h/2);
					updateRect(screen->w/2-80, screen->h/2-96, 160, 96);
					}
			break;

			case GAME:
				if(playerHp>0)
					gtime++;									// Licznik przetrwanego czasu
				else
					{
					sendState=0;
					mode=SENDSCORE;
					}
				if(gtime%(max(10, 60-gkills/5))==0)
					{
					if(rand()%2)
						muchy.push_back(new Mucha(mucha, rand()%screen->w, rand()%2*(screen->h+64)-32, 2+gkills/70, 50+gtime/60, grav, res));
					else
						muchy.push_back(new Mucha(mucha, rand()%2*(screen->w+64)-32, rand()%screen->w, 2+gkills/70, 50+gtime/60, grav, res));
					}
			break;

			case SENDSCORE:
				{
				char tmp[128]="";
				// Wpisywanie nicku
				switch(sendState)
					{
					case 0:
						if(event.type==SDL_KEYDOWN)
							{
							int k=event.key.keysym.sym;
							if(k!=lastKey)
								{
								lastKey=k;
								if(((k>=SDLK_a && k<=SDLK_z) || (k>=SDLK_0 && k<=SDLK_9)) && nickChr-nick<31)
									{
									(*nickChr)=k;
									if(key[SDLK_RSHIFT] || key[SDLK_LSHIFT])
										(*nickChr)-='a'-'A';
									nickChr++;
									(*nickChr)='\0';
									}
								else if((key[SDLK_RSHIFT] || key[SDLK_LSHIFT]) && k==SDLK_MINUS && nickChr-nick<31)
									{
									(*nickChr)='_';
									nickChr++;
									(*nickChr)='\0';
									}
								else if(k==SDLK_BACKSPACE && nickChr>nick)
									{
									nickChr--;
									(*nickChr)='\0';
									}
								}
							if(strlen(nick)>0 && key[SDLK_RETURN])
								sendState=1;
							}
						else
							lastKey=0;
						sprintf(tmp, "Pokonanych much: %d\nPrzetrwano: %ds\n\nWpisz nick: %s", gkills, gtime/60, nick);
					break;

					case 1:			// Info o wysylaniu
						sprintf(tmp, "Pokonanych much: %d\nPrzetrwano: %ds\n\nWysylanie wyniku...", gkills, gtime/60);
						sendState=2;
					break;

					case 2:			// Wysylanie
						{
						sprintf(tmp, "%d%s%dchcialbymmiecfrytkownice", gkills, nick, gtime);
						//printf("MD5 : %s\n", tmp);
						const char *md5tmp=md5(tmp, strlen(tmp));
						//printf("MD5 : %s\n", md5tmp);
						sprintf(tmp, "wysyl=1&wersja=1&nick=%s&muchy=%d&czas=%d&md5=%s", nick, gkills, gtime, md5tmp);		// Dodac crc // dodane md5 d;
						delete [] md5tmp;
						curl_easy_setopt(curlHandle, CURLOPT_WRITEFUNCTION, curlWrite);
						curl_easy_setopt(curlHandle, CURLOPT_URL, SCOREADDRSCRIPT);
						curl_easy_setopt(curlHandle, CURLOPT_POSTFIELDS, tmp);
						int ret=curl_easy_perform(curlHandle);
						if(ret==0)
							sendState=3;
						else
							sendState=4;
						}
					break;

					case 3:			// Wyslano ok
						gkills=0;
						gtime=0;
						sprintf(tmp, "Pokonanych much: %d\nPrzetrwano: %ds\n\nWyslano.", gkills, gtime/60);
						sendState=0;
						mode=SCORE;
					break;

					case 4:			// Wyslano nie ok
						sprintf(tmp, "Pokonanych much: %d\nPrzetrwano: %ds\n\nNie udalo sie wyslac. Wyslac ponownie? (Enter/Escape)", gkills, gtime/60);
						if(key[SDLK_RETURN])
							sendState=1;
					break;
					}
				// Wyswietlanie
				if(strlen(tmp)>0)
					hiscores.setText(tmp);
				gfx["hiscores.bmp"]->print(0, 0, hiscores.x-5, hiscores.y-5);
				hiscores.print();
				updateRect(hiscores.x-5, hiscores.y-5, 512+10, 266);
				}
			break;

			case SCORE:
				{
				char tmp[128]="";
				switch(sendState)
					{
					case 0:			// Pobieranie wynikow - info
						sprintf(tmp, "Pobieranie wynikow...");
						sendState=1;
					break;

					case 1:
						{
						curl_easy_setopt(curlHandle, CURLOPT_WRITEFUNCTION, curlWrite);
						curl_easy_setopt(curlHandle, CURLOPT_URL, SCOREADDR);
						int ret=curl_easy_perform(curlHandle);
						if(ret==0)
							sendState=2;
						else
							sendState=3;
						}
					break;

					case 2:			// win
						sprintf(tmp, "Pobrano.");
						sendState=4;
					break;

					case 3:			// fail >:
						sprintf(tmp, "Nie udalo sie pobrac wynikow.");
					break;

					case 4:			// parsowanie wynikow
						{
						wyniki.load("dl.txt");		// Zakladam, ze sie to nagle nie zmieni
						sendState=6;
						}
					break;

					case 5:			// Sortowanie po zabiciach
						{
						//printf("INFO: Sortowanie po zabiciach\n");
						char *wynikiStr;
						char *wynikiTmp;
						int count=min(wyniki.getCount(), wyniki.getMaxRows());
						try
							{
							wynikiStr=new char[count*64+8];		// Na twardo wpisana max dlugosc nicku
							memset(wynikiStr, 0, count*64+8);
							wynikiTmp=wynikiStr;
							}
						catch(bad_alloc &)
							{
							printf("FAIL: Nie udalo sie zajac miejsca na wyniki\n");
							return 202;
							}
						wyniki.sortKill();
						sprintf(wynikiTmp, "Muchy:\n");
						wynikiTmp+=7;
						//for(int i=count-1; i>=0; i--)
						for(int i=max(0, count-wyniki.getMaxRows()); i<count; i++)
							{
							//printf("%32s\n", wyniki.getHi(i)->nick);
							sprintf(wynikiTmp, "%02d.\t %s\t %d\n", wyniki.getHi(i)->id, wyniki.getHi(i)->nick, wyniki.getHi(i)->kills);
							wynikiTmp+=strlen(wynikiTmp);
							}
						tmp[0]='\0';
						hiscores.setText(wynikiStr);
						sendState=-1;
						delete [] wynikiStr;
						}
					break;

					case 6:			// Sortowanie po czasie
						{
						//printf("INFO: Sortowanie po czasie\n");
						char *wynikiStr;
						char *wynikiTmp;
						int count=min(wyniki.getCount(), wyniki.getMaxRows());
						try
							{
							wynikiStr=new char[count*64+8];		// Na twardo wpisana max dlugosc nicku
							memset(wynikiStr, 0, count*64+8);
							wynikiTmp=wynikiStr;
							}
						catch(bad_alloc &)
							{
							printf("FAIL: Nie udalo sie zajac miejsca na wyniki\n");
							return 202;
							}
						wyniki.sortTime();
						sprintf(wynikiTmp, "Czas:\n");
						wynikiTmp+=6;
						for(int i=max(0, count-wyniki.getMaxRows()); i<count; i++)
							{
							//printf("%32s\n", wyniki.getHi(i)->nick);
							sprintf(wynikiTmp, "%02d.\t %s\t %d\n", wyniki.getHi(i)->id, wyniki.getHi(i)->nick, wyniki.getHi(i)->time/(1000/FPSDELAY));
							wynikiTmp+=strlen(wynikiTmp);
							}
						tmp[0]='\0';
						hiscores.setText(wynikiStr);
						sendState=-1;
						delete [] wynikiStr;
						}
					break;

					default:
						//printf("%d\n", sendState);
						if(sendState!=-2 && event.type==SDL_KEYDOWN)
							sendState=-2;
						else if(sendState==-2 && event.type!=SDL_KEYDOWN)
							sendState=5+wyniki.type;
					break;
					}
				if(strlen(tmp)>0)
					hiscores.setText(tmp);
				gfx["hiscores.bmp"]->print(0, 0, hiscores.x-5, hiscores.y-5);
				hiscores.print();
				updateRect(hiscores.x-5, hiscores.y-5, 512+10, 266);
				}
			break;

			default:
				mode=MENU;
			break;
			}
		/***** Strzelanie *****/
		if(mode==GAME && SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
			{
//			for(int i=0; i<40; i++)
//				particles.push_back(Particle(gfx["krew.bmp"], mx, my, grav, res, rand()%3600/10.0,  rand()%20/10.0+0.5, 50));
			if(currWeapon>=0)
				{
				mainWepDelay=1000/FPSDELAY;
				switch(currWeapon)
					{
					case WMUCHOZOL:
						wepDelay=10*1000/FPSDELAY;
						weps.push_back(new Muchozol(0, mx, my, NULL, grav, res));
					break;
					case WCONCRETE:
						wepDelay=15*1000/FPSDELAY;
						weps.push_back(new Concrete(0, mx, my, gfx["kurczak.bmp"], grav, res));
					break;
					case WARMAGEDDON:
						wepDelay=8*1000/FPSDELAY;
						weps.push_back(new Armageddon(0, mx, my, gfx["meteor.bmp"], grav, res));
					break;
					case WAIRSTRIKE:
						wepDelay=3*1000/FPSDELAY;
						weps.push_back(new Airstrike(0, mx, my, gfx["airstrike.bmp"], grav, res));
					break;
					case WFLAME:
						wepDelay=5*1000/FPSDELAY;
						weps.push_back(new Flame(0, mx, screen->h+8, NULL, grav, res, wepDelay*2));
					break;
					default:
						wepDelay=2*1000/FPSDELAY;
						weps.push_back(new Bomb(0, mx, my, gfx["granat.bmp"], grav, res));
					break;
					}
//	wepDelay=60;		// <- skasowac i odkomentowac te wyzej	// imo lepiej po prostu zakomentowac o;
				weapons[currWeapon]--;
				currWeapon=-1;
				wepClick=-1;
				wepSel=0;
				}
			else if(mainWepDelay<=0 && wepSel==0)
				{
				mainWepDelay=1000/FPSDELAY;
				weps.push_back(new Explosion(0, mx, my, gfx["wybuch01.bmp"], grav, res, 5));
				weps.back()->setAnim(rand()%gfx["wybuch01.bmp"]->getAnimCount());
				}
			}
		/***** Dzialanie broni *****/
		for(list<Weapon *>::iterator it=weps.begin(); it!=weps.end(); it++)
			{
			if((*it)->getDone())
				{
				delete (*it);
				weps.erase(it--);
				continue;
				}
			(*it)->move();
			}
		/***** Wyswietlanie much *****/
		for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
			{
			Mucha *tmp=*it;
			if(playerHp<=0)
				{
				tmp->setHp(0);
				tmp->setDizzy();
				}
			if(tmp->getY()>screen->h+64)
				{
				delete *it;
				muchy.erase(it--);		// W razie potrzeby przywrocic 'it--' oraz 'it++' w for'ze		// Olane, dziala tak samo
				continue;
				}
			//updateRect(floor(tmp->getX())-tmp->getAnim()->spotx-1, floor(tmp->getY())-tmp->getAnim()->spoty-1, tmp->getAnim()->w+2, tmp->getAnim()->h+2);
			tmp->move();
			tmp->print();
			if(tmp->getX()>0 && tmp->getX()<screen->w && tmp->getY()>0 && tmp->getCol())
				{
				for(int i=0; i<5; i++)
					particles.push_back(Particle(gfx["krew.bmp"], tmp->getX(), tmp->getY(), grav, res, atan2(tmp->getVectors().x, tmp->getVectors().y)*180/3.14+rand()%20-10,  rand()%20/10.0+0.5, 50));
				tmp->setDizzy();
				continue;
				}
			/*** Drop ***/
			if(tmp->getHp()<=0)
				{
				if(tmp->getDizzy())
					continue;
				tmp->setDizzy();
				int wep=rand()%(150+gtime/30);
				int type=-1;
					// {WBOMB=0, WFLAME, WAIRSTRIKE, WCONCRETE, WARMAGEDDON, WMUCHOZOL, WLAST}
				if(wep<2 && weapons[WMUCHOZOL]<1)
					type=WMUCHOZOL;
				else if(wep<5 && weapons[WCONCRETE]<2)
					type=WCONCRETE;
				else if(wep<10)
					type=WARMAGEDDON;
				else if(wep<20)
					type=WAIRSTRIKE;
				else if(wep<40)
					type=WFLAME;
				else if(wep<70)
					type=WBOMB;
				//type=WBOMB;
				if(type>=0)
					drop.push_back(WeaponDrop(gfx["drop.bmp"], tmp->getX(), tmp->getY(), grav, res, 90, rand()%20/10.0+0.5, 1000, type));
				continue;
				}
			/*** Kolizja z kursorem ***/
			if(mx-kursor->getAnim(anim)->spotx+kursor->getAnim(anim)->w > tmp->getX()-tmp->getAnim()->spotx && mx-kursor->getAnim(anim)->spotx < tmp->getX()-tmp->getAnim()->spotx+tmp->getAnim()->w &&
				my-kursor->getAnim(anim)->spoty+kursor->getAnim(anim)->h > tmp->getY()-tmp->getAnim()->spoty && my-kursor->getAnim(anim)->spoty < tmp->getY()-tmp->getAnim()->spoty+tmp->getAnim()->h)
				{
				PlaySound("hit.wav");
				if(playerHp>0)
					playerHp--;//=10;//-
				particles.push_back(Particle(kursor, mx, my, grav, res, rand()%360,  rand()%20/10.0+0.5, 200));
				particles.back().setAnim(anim);
				//printf("OK  : Sprite.clear: Skasowano (%s)\n", (*it).first.c_str());
				tmp->setHp(0);			// IT'S OVER NINE THOUSAAAAAAAAAAAAAAAAAND!	// sry, juz nie >:
				gkills++;
				//tmp->setDizzy();
				}
			}
		/***** Wyswietlanie particli *****/
		for(list<Particle>::iterator it=particles.begin(); it!=particles.end(); it++)
			{
			it->move();
			if((*it).life--==0 || (*it).getY()>screen->h+32)
				{
				particles.erase(it--);
				continue;
				}
			else if(!(*it).fade && (*it).life==(*it).getSprite()->getAnim((*it).getAnimNum()+1)->frames-1)
				{
				(*it).fade=1;
				(*it).setAnim((*it).getAnimNum()+1);//=1;				// W razie segfaulta ta linia moze byc winna
				(*it).setFrame(0);
				(*it).setFdelay(0);
				}
			it->print();
			}
		/***** Wyswietlanie dropu *****/
		if(drop.size()>0)
			{
			for(list<WeaponDrop>::iterator it=drop.begin(); it!=drop.end(); it++)
				{
				it->move();
				if(it->getY()>screen->h+32)
					{
					drop.erase(it--);
					continue;
					}
				if(it->timer>0)
					it->timer--;
				else if(mx-kursor->getAnim(0)->spotx+kursor->getAnim(0)->w>it->getX()-it->getAnim()->spotx && mx-kursor->getAnim(0)->spotx<it->getX()-it->getAnim()->spotx+it->getAnim()->w &&
					my-kursor->getAnim(0)->spoty+kursor->getAnim(0)->h>it->getY()-it->getAnim()->spoty && my-kursor->getAnim(0)->spoty<it->getY()-it->getAnim()->spoty+it->getAnim()->h)
					{
					PlaySound("drop.wav");
					for(int i=0; i<10; i++)
						particles.push_back(Particle(gfx["iskra.bmp"], it->getX(), it->getY(), grav, res, rand()%360,  rand()%20/10.0+0.5, 20));
					weapons[it->type]++;
					drop.erase(it--);
					continue;
					}
				it->print();
				}
			}
		/***** Wybor broni *****/
		if(mainWepDelay>0)
			mainWepDelay--;
		if(wepDelay>0)
			{
			wepDelay--;
			particles.push_back(Particle(gfx["energia.bmp"], mx+4+rand()%4, my+9+rand()%6, antiGrav, res, 90,  rand()%20/10.0+0.5, 50));
			}
		if((SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3) && currWeapon<0) || wepClick>=0)
			{
			if(!wepSel)
				{
				mmx=mx;
				mmy=my;
				}
			wepSel=1;
			updateRect(mmx-WEAPONMENUSIZE-16, mmy-WEAPONMENUSIZE-16, WEAPONMENUSIZE*2+32, WEAPONMENUSIZE*2+64);
			if(mx<mmx-WEAPONMENUSIZE)
				mmx=mx+WEAPONMENUSIZE;
			else if(mx>mmx+WEAPONMENUSIZE)
				mmx=mx-WEAPONMENUSIZE;
			if(my<mmy-WEAPONMENUSIZE)
				mmy=my+WEAPONMENUSIZE;
			else if(my>mmy+WEAPONMENUSIZE)
				mmy=my-WEAPONMENUSIZE;
			/*if(mx<mmx-48)
				mmx=mx+48;
			else if(mx>mmx+48)
				mmx=mx-48;
			if(my<mmy-32)			// <- do odkomentowania przy ewentualnym powrocie do kwadratowej listy
				mmy=my+32;
			else if(my>mmy+32)
				mmy=my-32;*/
			for(int i=0; i<WEAPONCOUNT; i++)
				{
				int a=weapons[i]>0 && wepDelay<=0;
				int x=mmx+(sin(i*(3.14/180*360/WEAPONCOUNT))*WEAPONMENUSIZE);	// max(min(mmx, screen->w-64), 64)
				int y=mmy+(cos(i*(3.14/180*360/WEAPONCOUNT))*WEAPONMENUSIZE);	// max(min(mmy, screen->h-64), 64)
				if(mx>x-16 && mx<x+16 && my>y-16 && my<y+16)
					{
					if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1))
						{
						if(a>0)
							{
							a++;
							wepClick=i;
							}
						}
					else if(wepClick>=0)
						{
						currWeapon=i;
						wepClick=-1;
						}
					}
				else if(wepClick==i)
					wepClick=-1;
				//int x=mmx-48+i%3*32+16;
				//int y=mmy-32+i/3*32+16;
				gfxWeaponsMenu[i]->print(a, 0, x, y);
				}
			score.x=mmx-WEAPONMENUSIZE/2-28;
			score.y=mmy+WEAPONMENUSIZE/2+48;
			char wtmp[64];
			sprintf(wtmp, "%03d    %03d", gkills, gtime/(1000/FPSDELAY));
			score.setText(wtmp);
			score.print();
			//updateRect(mmx-64, mmy-64, 128, 128);
			updateRect(mmx-WEAPONMENUSIZE-16, mmy-WEAPONMENUSIZE-16, WEAPONMENUSIZE*2+32, WEAPONMENUSIZE*2+64);
			}
		else if(wepSel)
			{
			//updateRect(mmx-64, mmy-64, 128, 128);
			update=1;
			wepSel=0;
			}
		// /***** Sprawdzanie kolizji z graczem *****/	// <- jest w petli much
		anim=min((PLAYERHPANIM/2-playerHp)*2, PLAYERHPANIM-2);	// Na twardo wpisane max hp gracza (100)	// olane po raz kolejny
		kursor->print(anim, 0, mx, my);
		/***** Update *****/
		//update=0;
		//for(int i=0; i<1000; i++)
		//	putPix(screen, rand()%screen->w, rand()%screen->h, 0xFF0000);
		if(update)
			{
			update=0;
			SDL_Flip(screen);
			}
		else
			SDL_UpdateRects(screen, updates, rects);
		//memset(rects, 0, maxUpdates*sizeof(SDL_Rect));
		#ifndef DEBUG
		if(czas!=time(NULL))
			{
			czas=time(NULL);
			printf("time: %d, parts: %d, fly: %d, updates: %d, weps: %d, delay: %d-%d\n", SDL_GetTicks()-frameTime, particles.size(), muchy.size(), updates, weps.size(), mainWepDelay, wepDelay);
			}
		#else
		printf("time: %d, parts: %d, fly: %d, updates: %d, weps: %d, delay: %d-%d\t\t\r", SDL_GetTicks()-frameTime, particles.size(), muchy.size(), updates, weps.size(), mainWepDelay, wepDelay);
		#endif
		updates=0;
		if(SDL_GetTicks()-frameTime<FPSDELAY-1 && !key[SDLK_RSHIFT])
			SDL_Delay(max(0, FPSDELAY-(int)(SDL_GetTicks()-frameTime)));
		//printf(" ");
		}
	Sprite::clear(gfx);
	for(map<string, Sprite *>::iterator it=gfx.begin(); it!=gfx.end(); it++)
		delete it->second;
	particles.clear();
	muchy.clear();
	drop.clear();
	weps.clear();
	wyniki.clear();
	delete [] rects;
	//rects.clear();
	SDL_FreeSurface(background);
	SDL_FreeSurface(screen);
	SDL_FreeSurface(icon);
	SDL_CloseAudio();
	SDL_Quit();
	printf("INFO: Stop\n");
	return 0;
	}
