#include "main.h"

Particle::Particle(Sprite *setSprite, int setX, int setY, vect &setGrav, vect &setRes, float setAng, float setForce, int setLife): Object(0, setX, setY, setSprite, setGrav, setRes)
	{
	vectors.x=cos(setAng*0.01745)*setForce;				// <- zapamietaj !0.01745! a nie 0.1745 x;
	vectors.y=-sin(setAng*0.01745)*setForce;
	maxVectors.x=10; maxVectors.y=10;
	life=setLife;
	fade=0;
	//printf("Particle: %.2f %.2f (% .2f, % .2f)\n", setAng, setForce, cos(setAng*0.01745), sin(setAng*0.01745));	// 20103005, wez patrz co robisz, zamieniles sinusa i cosinusa miejscami x;
	}

Particle::~Particle()
	{
	if(run)
		updateRect(x-anim->spotx, y-anim->spoty, anim->w, anim->h);
	}

void Particle::move()
	{
	updateRect(x-anim->spotx, y-anim->spoty, anim->w, anim->h);
	if(life<=0)
		return;
	// Ruch
	if(grav.x!=0)
		if(vectors.x<maxVectors.x-1 || vectors.x>maxVectors.x+1)
			vectors.x+=grav.x;
	if(grav.y!=0)
		if(vectors.y<maxVectors.y-1 || vectors.y>maxVectors.x+1)
			vectors.y+=grav.y;
	// Opor
	if(vectors.x>0)
		vectors.x-=res.x;
	else if(vectors.x<0)
		vectors.x+=res.x;
	if(vectors.y>0)
		vectors.y-=res.y;
	else if(vectors.y<0)
		vectors.y+=res.y;
	x+=vectors.x;
	y+=vectors.y;
	updateRect(x-anim->spotx, y-anim->spoty, anim->w, anim->h);
	}
